#ifndef __GS_SOLVER_H__
#define __GS_SOLVER_H__

#include "GS_Solver_Defs.h"
#include "SparseSolver.h"

class GS_Solver
{
public:
	typedef struct _Params
	{
		Indices levelsToSolve;
		Indices channelsToSolve;
		double accuracy;
		int maxIters;
		int maxLevelsInPrecond;
		double pinchFuncScale, pinchFuncExp;
		double fidelity_data;
		double fidelity_sGrad;
		bool useGlobalDatacost;
		bool useSDI_weighing;
		double sdiNorm;
		bool writeProb;
		bool writeSol;
		string outDir;
		static _Params Default();
		void Dump(string prefix);
	} Params;

private:
	Params      params;
	GS_Problem* problem;
	GS_P_Shape  problemShape;

public:
	GS_Solver(GS_Problem* _problem, Params params = Params::Default());
	void Solve();
private:
	void solveChannel(int iChannel);
	void defineChannelEqs(int iChannel, int iProbLevel, int iSolLevel, SparseSolver &solver);
};

#endif

