#include "SparseSymMat_CSR.h"

void 
SparseSymMat_CSR::DumpMatlab(char* matName)
{
	printf("%s = [ ", matName);

	for(size_v iRow = 0; iRow < this->rowCount; iRow++)
	{
		size_vv startNonZeroIndex = this->rowIndices[iRow] - 1;
		size_v  startColumnIndex  = this->columns[startNonZeroIndex] - 1;
		size_vv endNonZeroIndex   = this->rowIndices[iRow + 1] - 1 - 1;
		size_v  endColumnIndex    = this->columns[endNonZeroIndex] - 1;

		for(size_v iCol = 0; iCol < startColumnIndex; iCol++)
		{
			printf(" %1.4e", 0.0f);
		}

		printf(" %1.4e", (float) this->values[startNonZeroIndex]);
		for(size_v iElem = startNonZeroIndex + 1; iElem <= endNonZeroIndex; iElem++)
		{
			int zeroElemsCount = this->columns[iElem] - this->columns[iElem - 1] - 1;
			for(int jElem = 0; jElem < zeroElemsCount; jElem++)
			{
				printf(" %1.4e", 0.0f);
			}
			printf(" %1.4e", (float) this->values[iElem]);
		}

		for(size_v iCol = endColumnIndex + 1; iCol < this->colCount; iCol++)
		{
			printf(" %1.4e", 0.0f);
		}

		printf(";");
	}

	printf("]\n");
}


