#include "SparseSymMat_CSR.h"
#include "omp.h"

void 
SparseSymMat_CSR::Multiply_pro(size_v inLen, size_v outLen, 
							   const precise* inVec, precise* outVec) const
{
	INSIST(inLen  == this->colCount);
	INSIST(outLen == this->rowCount);

	Vec::SetToNull(outLen, outVec);
	
	//#pragma omp parallel for
	for(size_v iRow = 0; iRow < this->rowCount; iRow++)
	{
		size_vv startNonZeroIndex = this->rowIndices[iRow] - 1; //one based indexing
		size_vv endNonZeroIndex   = this->rowIndices[iRow + 1] - 1 - 1; //one based indexing
	
		for(size_vv iElem = startNonZeroIndex; iElem <= endNonZeroIndex; iElem++)
		{
			size_v iCol = this->columns[iElem] - 1; //one based indexing
			float temp = inVec[iCol] * this->values[iElem];
			//#pragma omp atomic
				outVec[iRow] += temp;
			if(iCol != iRow)
			{
				temp = inVec[iRow] * this->values[iElem];
				//#pragma omp atomic
					outVec[iCol] += temp;
			}
		}
	}
}

