#include "GSF_Deblock.h"

GSF_Deblock::Params GSF_Deblock::Params::Default()
{
	string curveStr = "500 "                           //number of samples on the x-axis
		              "0.000000e+000 1.1.000000e+000 " //min and max of curve response
					  "3 "                             //number of keypoints in curve
					  "0.000000e+000 0.000000e+000 "   //keypoint coordinates
					  "1.400000e-001 6.250000e-002 "
					  "1.000000e+000 1.000000e+000 ";
	Curve deblockingCurve;
	deblockingCurve.Load(curveStr);

	return Params(deblockingCurve, 10.0f);
}

void GSF_Deblock::Params::Dump(string prefix)
{
	const char* prefixPtr = prefix.c_str();

	printf("\n");
	printf("%s GSF Deblock params:\n", prefixPtr);
	printf("%s   uv weight multiers: %f\n", prefixPtr, this->uvMult);
	printf("%s   block grad curve:\n", prefixPtr);
	this->blockGradCurve.Dump(prefix + "  ");

	printf("\n");
}

