#ifndef __FILTER_DRIVER_H__
#define __FILTER_DRIVER_H__

#include "GS_Filter_Defs.h"

class Filter_Driver
{
public:
	typedef enum
	{
		FT_NULL    = 0,
		FT_SHARPEN,
		FT_ELE,
		FT_TEST,
		FT_RELIGHT,
		FT_DEBLOCK,
		FT_MOTION_BLUR,
		FT_GRAD_CURVE,
		FT_NPR,
		FT_TM,
		FT_COLORIZE,
		FT_DEFAULT = FT_NULL
	} FT_Type;

	typedef struct _Params
	{
		FT_Type type;

		GS_Problem::Params     gspParams;
		GS_Solver::Params      gssParams;
		GSF_ELE::Params        gsf_EleParams;
		GSF_Test::Params       gsf_testParams;
		GSF_Relight::Params    gsf_relightParams;
		GSF_Deblock::Params    gsf_deblockParams;
		GSF_Sharpen::Params    gsf_SharpenParams;
		GSF_MotionBlur::Params gsf_motionBlurParams;
		GSF_GradCurve::Params  gsf_gradCurveParams;
		GSF_NPR::Params        gsf_nprParams;
		GSF_ToneMap::Params    gsf_tmParams;
		GSF_Colorize::Params   gsf_clzParams;		

		static _Params Default();
		void Dump(string prefix);
		static string GetFilterName(FT_Type type);
	} Params;

public:
	static GS_Image Filter(string fileName,     const Params& params);
	static GS_Image Filter(GS_Problem* problem, const Params& params);
	static void TestFilter(string fileName,     const Params& params);
};

#endif

