#ifndef __GSF_GRAD_CURVE_H__
#define __GSF_GRAD_CURVE_H__

#include "GS_Filter.h"
#include "Curve.h"

class GSF_GradCurve : public GS_Filter
{
public:
	typedef struct _Params 
	{
		Curve gradCurve;
		_Params()
		{
		}
		static _Params Default();
		static _Params Sharpen();
		static _Params Blur();
		static _Params SmartSharpen();
		static _Params NPR();
		void Dump(string prefix);
	}Params;

private:
	Params params;

public:
	GSF_GradCurve(GS_Problem *_problem, const Params &_params = Params::Default());
	void FilterLevel(int iLevel, void* userData = NULL);

public: //GSF_GradCurve-Driver.cpp	

	static GS_Problem::Params GS_Problem_Params_Default();
	static GS_Solver::Params GS_Solver_Params_Default();
	static GS_Solver::Params GS_Solver_Params_NPR();

	static GS_Image GradCurve(GS_ProblemInput probInput,
							  Params fltParams              = Params::Default(),
							  GS_Problem::Params probParams = GS_Problem_Params_Default(),
							  GS_Solver::Params solParams   = GS_Solver_Params_Default());

	static void TestFilters(string imgFN, string outDir = "");
};

#endif
