#include "GSF_NPR.h"

GSF_NPR::Params GSF_NPR::Params::Default()
{
	Params params;

	params.edgeLenNorm = 1250.0f;

	string curveStr = "500 "                           //number of samples on the x-axis
		              "0.000000e+000 4.750000e+000 "   //min and max of curve response
					  "5 "                             //number of keypoints in curve
					  "0.000000e+000 0.000000e+000 "   //keypoint coordinates
					  "6.000000e-002 5.714000e-006 "
					  "1.827957e-001 9.392265e-003 "
					  "3.750000e-001 2.857000e-002 "
					  "1.000000e+000 1.000000e+000 ";

	params.edgeLenCurve.Load(curveStr);

	return params;
}

GSF_NPR::Params GSF_NPR::Params::Default_EdgeVis()
{
	Params params;

	params.edgeLenNorm = 1500.0f;

	string curveStr = "500 "                           //number of samples on the x-axis
		              "0.000000e+000 1.000000e+000 "   //min and max of curve response
					  "5 "                             //number of keypoints in curve
					  "0.000000e+000 0.000000e+000 "   //keypoint coordinates
					  "6.000000e-002 5.714000e-006 "
					  "1.827957e-001 9.392265e-003 "
					  "3.750000e-001 2.857000e-002 "
					  "1.000000e+000 1.000000e+000 ";

	params.edgeLenCurve.Load(curveStr);

	return params;
}

void GSF_NPR::Params::Dump(string prefix)
{
	const char* prefixPtr = prefix.c_str();

	printf("\n");
	printf("%s GSF NPR params:\n", prefixPtr);
	printf("%s  edge length norm - %f:\n", prefixPtr, this->edgeLenNorm);
	printf("%s  edge length curve:\n", prefixPtr);
	this->edgeLenCurve.Dump(prefix + "  ");
	printf("\n");
}


