#ifndef __GSF_NPR_H__
#define __GSF_NPR_H__

#include "GS_Filter.h"
#include "Curve.h"
#include "EdgeMetrics.h"
#include "Transform-3x3.h"

class GSF_NPR : public GS_Filter
{
public:
	typedef struct _Params 
	{
		float edgeLenNorm;
		Curve edgeLenCurve;
		_Params(float _edgeLenNorm = 1250.0f)
		{
			this->edgeLenNorm = _edgeLenNorm;
		}
		static _Params Default();
		static _Params Default_EdgeVis();
		void Dump(string prefix);
	}Params;

private:
	Params params;

public:
	GSF_NPR(GS_Problem *_problem, const Params &_params = Params::Default());
	void FilterLevel(int iLevel, void* userData = NULL);

	Params GetParams()
	{
		return this->params;
	}

public: //GSF_NPR-Driver.cpp	

	static GS_Problem::Params GS_Problem_Params_Default();
	static GS_Solver::Params GS_Solver_Params_Default();

	static GS_Image NPR(GS_ProblemInput probInput,
						Params fltParams              = Params::Default(),
						GS_Problem::Params probParams = GS_Problem_Params_Default(),
						GS_Solver::Params solParams   = GS_Solver_Params_Default());


	static void TestFilters(string imgFN, string outDir = "");

public: //GSSF_NPR-EdgeVis.cpp
	static GS_Image VisBrushStrokes(const GS_Image &baseImg, const EdgeMetrics &emData, 
								    Params params = Params::Default_EdgeVis());

	static GS_Image VisBrushStrokes1(const GS_Image &baseImg, const EdgeMetrics &emData, 
								     Params params = Params::Default_EdgeVis());

	static GS_Image VisBrushStrokes2(const GS_Image &baseImg, const EdgeMetrics &emData, 
		                             const FVector3 &strokeCol = FVector3(0.0f, 0.0f, 0.0f), 
									 Params params = Params::Default_EdgeVis());
};

#endif


