#include "GSF_Sharpen.h"

GSF_Sharpen::GSF_Sharpen(GS_Problem* _problem, const Params &_params) : GS_Filter(_problem)
{
	this->params = _params;
}

void GSF_Sharpen::FilterLevel(int iLevel, void* userData)
{	
	Params* levelParams = (userData == NULL) ? &this->params : (Params*) userData;

	GS_ProblemLevel* levelProb = this->problem->GetLevel(iLevel);

	GS_Image levelOrgGF_X, levelOrgGF_Y;
	GS_Image levelFltGF_X, levelFltGF_Y;
	levelProb->GetDataGF(levelOrgGF_X, levelOrgGF_Y, levelFltGF_X, levelFltGF_Y);

	CShape imgShape = levelOrgGF_X.Shape();
	int pixelCount = imgShape.PixelCount();
	for(int iPixel = 0; iPixel < pixelCount; iPixel++)
	{
		levelFltGF_X[iPixel] = (imgType) (levelParams->multiplier * levelOrgGF_X[iPixel]);
		levelFltGF_Y[iPixel] = (imgType) (levelParams->multiplier * levelOrgGF_Y[iPixel]);
	}
}


