#ifndef __GSF_TEST_H__
#define __GSF_TEST_H__

#include "GS_Filter.h"
#include "Curve.h"

class GSF_Test : public GS_Filter
{
public:

	typedef struct _Params 
	{
		float lightDircAng;
		float lightStrength;
		_Params(float _lightDirc = 45, float _lightStrength = 1.0f)
		{
			this->lightDircAng  = _lightDirc;
			this->lightStrength = _lightStrength;
		}
		static _Params Default();
		void Dump(string prefix);
	}Params;

private:
	Params params;

public:
	GSF_Test(GS_Problem *_problem, const Params &_params = Params::Default());
	void FilterLevel(int iLevel, void* userData = NULL);

	Params GetParams()
	{
		return this->params;
	}

private:
	string getScribblesFN(string orgFN);

public: //GSF_Test-Driver.cpp	

	static GS_Problem::Params GS_Problem_Params_Default();
	static GS_Solver::Params GS_Solver_Params_Default();

	static GS_Image Test(GS_ProblemInput probInput,
					     Params fltParams              = Params::Default(),
						 GS_Problem::Params probParams = GS_Problem_Params_Default(),
						 GS_Solver::Params solParams   = GS_Solver_Params_Default());


	static void TestFilters(string imgFN, string outDir = "");
};

#endif
