#include "LinearSolver.h"
#include "SparseSqrSymMat.h"

void LinearSolver::SolveRandSys_GD(int size)
{
	SparseSqrSymMat mat;
	precise *xOrg = new precise[size];
	precise *xSol = new precise[size];
	precise *b    = new precise[size];
	INSIST(xOrg != NULL);
	INSIST(xSol != NULL);
	INSIST(b    != NULL);

	mat = SparseSqrSymMat::GenRandMat(size);	
	Vec::FillRandValues(size, xOrg);
	mat.Multiply(size, size, xOrg, b);
	Vec::SetToNull(size, xSol);
	
	LinearSolverParams params = LinearSolverParams::Default();
	//LinearSolver::Solve_GD(size, &mat, xSol, b, params);
	LinearSolver::Solve_CG(size, &mat, xSol, b, params);

	mat.DumpMatlab("A");	
	Vec::DumpMatlab(size, xOrg, "xIn");
	Vec::DumpMatlab(size, xSol, "xSol");
	Vec::DumpMatlab(size, b, "b");

	delete [] xOrg;
	delete [] xSol;
	delete [] b;
}