#ifndef __CHANNELS_TYPES_H__
#define __CHANNELS_TYPES_H__

#include <stdlib.h>

typedef enum
{
	CT_UNKNOWN = 0,
	CT_RGB,
	CT_LOG_RGB,
	CT_YCrCb,
	CT_LOG_YCrCb,
	CT_YUV,
	CT_LOG_YUV,
	CT_LAB,
	CT_HSV,
	CT_LUM,
	CT_LOG_LUM,
	CT_RGB_R,
	CT_RGB_G,
	CT_RGB_B,
	CT_LOG_RGB_R,
	CT_LOG_RGB_G,
	CT_LOG_RGB_B,
	CT_YCrCb_Cr,
	CT_YCrCb_Cb,
	CT_LOG_YCrCb_Cr,
	CT_LOG_YCrCb_Cb,
	CT_YUV_U,
	CT_YUV_V,
	CT_LOG_YUV_U,
	CT_LOG_YUV_V,
	CT_LAB_L,
	CT_LAB_A,
	CT_LAB_B,
	CT_HSV_H,
	CT_HSV_S,
	CT_HSV_V,
	CT_DEFAULT    = CT_RGB,
	CT_LAST_INDEX = CT_HSV_V
} ChannelsType;

const extern char* ChannelsTypeStr[CT_LAST_INDEX + 2];

const extern char* SubChannelTypeStr[CT_LAST_INDEX + 1][3];

const static ChannelsType SubChannelType[CT_LAST_INDEX + 1][3] =
{
	{CT_UNKNOWN,      CT_UNKNOWN,      CT_UNKNOWN},
	{CT_RGB_R,        CT_RGB_G,        CT_RGB_B},
	{CT_LOG_RGB_R,    CT_LOG_RGB_G,    CT_LOG_RGB_B},
	{CT_LUM,          CT_YCrCb_Cr,     CT_YCrCb_Cb},
	{CT_LOG_LUM,      CT_LOG_YCrCb_Cr, CT_LOG_YCrCb_Cb},
	{CT_LUM,          CT_YUV_U,        CT_YUV_V},
	{CT_LOG_LUM,      CT_LOG_YUV_U,    CT_LOG_YUV_V},
	{CT_LAB_L,        CT_LAB_A,        CT_LAB_B},
	{CT_HSV_H,        CT_HSV_S,        CT_HSV_V},
	{CT_LUM,          CT_UNKNOWN,      CT_UNKNOWN},
	{CT_LOG_LUM,      CT_UNKNOWN,      CT_UNKNOWN},
	{CT_RGB_R,        CT_UNKNOWN,      CT_UNKNOWN},
	{CT_RGB_G,        CT_UNKNOWN,      CT_UNKNOWN},
	{CT_RGB_B,        CT_UNKNOWN,      CT_UNKNOWN},
	{CT_LOG_RGB_R,    CT_UNKNOWN,      CT_UNKNOWN},
	{CT_LOG_RGB_G,    CT_UNKNOWN,      CT_UNKNOWN},
	{CT_LOG_RGB_B,    CT_UNKNOWN,      CT_UNKNOWN},
	{CT_YCrCb_Cr,     CT_UNKNOWN,      CT_UNKNOWN},
	{CT_YCrCb_Cb,     CT_UNKNOWN,      CT_UNKNOWN},
	{CT_LOG_YCrCb_Cr, CT_UNKNOWN,      CT_UNKNOWN},
	{CT_LOG_YCrCb_Cb, CT_UNKNOWN,      CT_UNKNOWN},
	{CT_YUV_U,        CT_UNKNOWN,      CT_UNKNOWN},
	{CT_YUV_V,        CT_UNKNOWN,      CT_UNKNOWN},
	{CT_LOG_YUV_U,    CT_UNKNOWN,      CT_UNKNOWN},
	{CT_LOG_YUV_V,    CT_UNKNOWN,      CT_UNKNOWN},
	{CT_LAB_L,        CT_UNKNOWN,      CT_UNKNOWN},
	{CT_LAB_A,        CT_UNKNOWN,      CT_UNKNOWN},
	{CT_LAB_B,        CT_UNKNOWN,      CT_UNKNOWN},
	{CT_HSV_H,        CT_UNKNOWN,      CT_UNKNOWN},
	{CT_HSV_S,        CT_UNKNOWN,      CT_UNKNOWN},
	{CT_HSV_V,        CT_UNKNOWN,      CT_UNKNOWN},
};

#endif
