#ifndef __GS_IMAGE_PANEL_H__
#define __GS_IMAGE_PANEL_H__

#include "Definitions.h"
#include "GS_UI_Definitions.h"
#include "ImageData.h"

class GS_ImagePanel : public Fl_Box
{
public:
	typedef enum
	{
		PT_IMG = 0,
		PT_RESULT,
		PT_DEFAULT = PT_IMG
	} PanelType;

private:
	ImageData *imgData;
	Fl_RGB_Image *wg_displayImg;
	uchar        *displayImgData;
	PanelType    panelType;

	vector<Callback> resizeCallbacks;

public:
	GS_ImagePanel(ImageData *imageData);
	~GS_ImagePanel();
	void SetPanelType(PanelType _panelType);
	PanelType GetPanelType();
	void Add_resize_callback(Callback callback);
	static void UpdateImgContent(void *imgPanelPtr);

private:
	void make_resize_callbacks();
	void updateDisplay();	
	CByteImage getPanelSourceImg();
};

#endif