#ifndef __GS_IMAGE_DATA_H__
#define __GS_IMAGE_DATA_H__

#include "Definitions.h"
#include "ImageIO.h"
#include "GS_Problem.h"

class ImageData
{
public:
	CShape imgShape;
	CByteImage img;
	CByteImage result;
	string imgFileName;	
	GS_Problem* prob;

	vector<Callback> contentUpdate_Callbacks;

public:
	ImageData();
	void Load(string fileName, GS_Problem::Params probParams);
	void Add_contentUpdate_callback(Callback callback);
	static void ResultUpdateCallback(void* imgDataPtr);

private:
	void make_contentUpdate_callbacks();
	void resultUpdateCallback();
	void getCurrentResult();
};

#endif