#ifndef __GS_FUNC_VIS_H__
#define __GS_FUNC_VIS_H__

#include "Definitions.h"
#include "GS_UI_Definitions.h"

class GS_FuncVis
{

public:
	typedef struct _GS_FuncVisParams
	{
		int x, y, w, h;
		double minX, maxX;
		double minY, maxY;
		Callback_Double funcEvaluator;
	} GS_FuncVisParams;


private:

	static const int xPaddingLeft   = 25;
	static const int xPaddingRight  = 5;
	static const int yPaddingTop    = 5;
	static const int yPaddingBottom = 15;
	static const int axisCross      = 10;
	
public:
	static GS_Line GetGraphDiag(const GS_FuncVisParams &params);

	static GS_Line draw(const GS_FuncVisParams &params);	

private:

	static void getAxisLines(GS_Line &xAxis, GS_Line &yAxis,
							 const GS_FuncVisParams &params);

	static GS_Line getGraphDiag(const GS_Line &xAxis, const GS_Line &yAxis, 
								const GS_FuncVisParams &params);

	static void drawGrid(int xAxisY, int yAxisX, const GS_FuncVisParams &params);	

	static void drawAxis(const GS_Line &xAxis, const GS_Line &yAxis);

	static void drawGraphDiag(const GS_Line &xAxis, const GS_Line &yAxis);

	static void drawAxisLabels(const GS_Line &xAxis, const GS_Line &yAxis, 
							   const GS_FuncVisParams &params);	

	static void drawFuncPlot(const GS_Line &xAxis, const GS_Line &yAxis, 
							 const GS_FuncVisParams &params);
};

#endif